Index: drivers/filesystems/btrfs/balance.c
===================================================================
--- drivers/filesystems/btrfs/balance.c	(révision 74430)
+++ drivers/filesystems/btrfs/balance.c	(copie de travail)
@@ -2426,8 +2322,14 @@
         return Status;
     }
 
-    if (!keycmp(searchkey, tp.item->key))
-        delete_tree_item(Vcb, &tp, &rollback);
+    if (!keycmp(searchkey, tp.item->key)) {
+        Status = delete_tree_item(Vcb, &tp);
+        
+        if (!NT_SUCCESS(Status)) {
+            ERR("delete_tree_item returned %08x\n", Status);
+            return Status;
+        }
+    }
     
     // update superblock
     
@@ -2435,17 +2337,18 @@
     Vcb->superblock.total_bytes -= dev->devitem.num_bytes;
     Vcb->devices_loaded--;
     
-    first_dev = first_device(Vcb) == dev;
-    
     RemoveEntryList(&dev->list_entry);
     
     // flush
     
-    do_write(Vcb, NULL, &rollback);
+    Status = do_write(Vcb, NULL);
+    if (!NT_SUCCESS(Status))
+        ERR("do_write returned %08x\n", Status);
     
     free_trees(Vcb);
     
-    clear_rollback(Vcb, &rollback);
+    if (!NT_SUCCESS(Status))
+        return Status;
     
     if (!dev->readonly) {
         Status = remove_superblocks(dev);
@@ -2455,39 +2358,66 @@
     
     // remove entry in volume list
     
-    ExAcquireResourceExclusiveLite(&volumes_lock, TRUE);
+    vde = Vcb->vde;
     
-    le = volumes.Flink;
-    while (le != &volumes) {
-        volume* v = CONTAINING_RECORD(le, volume, list_entry);
+    ExAcquireResourceExclusiveLite(&vde->child_lock, TRUE);
+    
+    le = vde->children.Flink;
+    while (le != &vde->children) {
+        volume_child* vc = CONTAINING_RECORD(le, volume_child, list_entry);
         
-        if (RtlCompareMemory(&Vcb->superblock.uuid, &v->fsuuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID) &&
-            RtlCompareMemory(&dev->devitem.device_uuid, &v->devuuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID)) {
+        if (RtlCompareMemory(&dev->devitem.device_uuid, &vc->uuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID)) {
             PFILE_OBJECT FileObject;
             PDEVICE_OBJECT mountmgr;
             UNICODE_STRING mmdevpath;
         
-            RemoveEntryList(&v->list_entry);
-        
-            // re-add entry to mountmgr
-
-            if (!first_dev && v->part_num != 0) {
+            vde->children_loaded--;
+            
+            if (vc->had_drive_letter) { // re-add entry to mountmgr
                 RtlInitUnicodeString(&mmdevpath, MOUNTMGR_DEVICE_NAME);
                 Status = IoGetDeviceObjectPointer(&mmdevpath, FILE_READ_ATTRIBUTES, &FileObject, &mountmgr);
                 if (!NT_SUCCESS(Status))
                     ERR("IoGetDeviceObjectPointer returned %08x\n", Status);
                 else {
-                    add_volume(mountmgr, &v->devpath);
+                    MOUNTDEV_NAME mdn;
+                    
+                    Status = dev_ioctl(dev->devobj, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, NULL, 0, &mdn, sizeof(MOUNTDEV_NAME), TRUE, NULL);
+                    if (!NT_SUCCESS(Status) && Status != STATUS_BUFFER_OVERFLOW)
+                        ERR("IOCTL_MOUNTDEV_QUERY_DEVICE_NAME returned %08x\n", Status);
+                    else {
+                        MOUNTDEV_NAME* mdn2;
+                        ULONG mdnsize = offsetof(MOUNTDEV_NAME, Name[0]) + mdn.NameLength;
+                        
+                        mdn2 = ExAllocatePoolWithTag(PagedPool, mdnsize, ALLOC_TAG);
+                        if (!mdn2)
+                            ERR("out of memory\n");
+                        else {
+                            Status = dev_ioctl(dev->devobj, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, NULL, 0, mdn2, mdnsize, TRUE, NULL);
+                            if (!NT_SUCCESS(Status))
+                                ERR("IOCTL_MOUNTDEV_QUERY_DEVICE_NAME returned %08x\n", Status);
+                            else {
+                                UNICODE_STRING name;
+                                
+                                name.Buffer = mdn2->Name;
+                                name.Length = name.MaximumLength = mdn2->NameLength;
+                                
+                                Status = mountmgr_add_drive_letter(mountmgr, &name);
+                                if (!NT_SUCCESS(Status))
+                                    WARN("mountmgr_add_drive_letter returned %08x\n", Status);
+                            }
+                            
+                            ExFreePool(mdn2);
+                        }
+                    }
+                    
                     ObDereferenceObject(FileObject);
                 }
             }
             
-            part0 = v->part_num == 0 ? TRUE : FALSE;
-        
-            if (v->devpath.Buffer)
-                ExFreePool(v->devpath.Buffer);
+            ExFreePool(vc->pnp_name.Buffer);
+            RemoveEntryList(&vc->list_entry);
+            ExFreePool(vc);
             
-            ExFreePool(v);
             break;
         }
         
@@ -2494,40 +2424,31 @@
         le = le->Flink;
     }
     
-    ExReleaseResourceLite(&volumes_lock);
-    
-    if (first_dev) {
-        PDEVICE_OBJECT DeviceObject, olddev;
-        device* newfirstdev;
-        PFILE_OBJECT FileObject;
-        UNICODE_STRING mmdevpath;
-        PDEVICE_OBJECT mountmgr;
+    if (vde->children_loaded > 0 && vde->device->Characteristics & FILE_REMOVABLE_MEDIA) {
+        vde->device->Characteristics &= ~FILE_REMOVABLE_MEDIA;
         
-        DeviceObject = Vcb->Vpb->DeviceObject;
-        
-        olddev = DeviceObject->Vpb->RealDevice;
-        newfirstdev = first_device(Vcb);
-        
-        ObReferenceObject(newfirstdev->devobj);
-        DeviceObject->Vpb->RealDevice = newfirstdev->devobj;
-        ObDereferenceObject(olddev);
-        
-        RtlInitUnicodeString(&mmdevpath, MOUNTMGR_DEVICE_NAME);
-        Status = IoGetDeviceObjectPointer(&mmdevpath, FILE_READ_ATTRIBUTES, &FileObject, &mountmgr);
-        if (!NT_SUCCESS(Status))
-            ERR("IoGetDeviceObjectPointer returned %08x\n", Status);
-        else {
-            Status = replace_mount_dev(Vcb, dev, mountmgr, part0);
-            if (!NT_SUCCESS(Status))
-                ERR("replace_mount_dev returned %08x\n", Status);
+        le = vde->children.Flink;
+        while (le != &vde->children) {
+            volume_child* vc = CONTAINING_RECORD(le, volume_child, list_entry);
             
-            ObDereferenceObject(FileObject);
+            if (vc->devobj->Characteristics & FILE_REMOVABLE_MEDIA) {
+                vde->device->Characteristics |= FILE_REMOVABLE_MEDIA;
+                break;
+            }
+            
+            le = le->Flink;
         }
-        
     }
     
+    vde->num_children = Vcb->superblock.num_devices;
+    
+    ExReleaseResourceLite(&vde->child_lock);
+    
     // free dev
     
+    if (dev->trim && !dev->readonly && !Vcb->options.no_trim)
+        trim_whole_device(dev);
+    
     ObDereferenceObject(dev->devobj);
     
     while (!IsListEmpty(&dev->space)) {
@@ -2539,9 +2460,127 @@
     
     ExFreePool(dev);
     
+    if (Vcb->trim) {
+        Vcb->trim = FALSE;
+        
+        le = Vcb->devices.Flink;
+        while (le != &Vcb->devices) {
+            device* dev2 = CONTAINING_RECORD(le, device, list_entry);
+            
+            if (dev2->trim) {
+                Vcb->trim = TRUE;
+                break;
+            }
+            
+            le = le->Flink;
+        }
+    }
+    
+    FsRtlNotifyVolumeEvent(Vcb->root_file, FSRTL_VOLUME_CHANGE_SIZE);
+    
     return STATUS_SUCCESS;
 }
 
+static void trim_unalloc_space(device_extension* Vcb, device* dev) {
+    DEVICE_MANAGE_DATA_SET_ATTRIBUTES* dmdsa;
+    DEVICE_DATA_SET_RANGE* ranges;
+    ULONG datalen, i;
+    KEY searchkey;
+    traverse_ptr tp;
+    NTSTATUS Status;
+    BOOL b;
+    UINT64 lastoff = 0x100000; // don't TRIM the first megabyte, in case someone has been daft enough to install GRUB there
+    LIST_ENTRY* le;
+    
+    dev->num_trim_entries = 0;
+    
+    searchkey.obj_id = dev->devitem.dev_id;
+    searchkey.obj_type = TYPE_DEV_EXTENT;
+    searchkey.offset = 0;
+    
+    Status = find_item(Vcb, Vcb->dev_root, &tp, &searchkey, FALSE, NULL);
+    if (!NT_SUCCESS(Status)) {
+        ERR("find_item returned %08x\n", Status);
+        return;
+    }
+    
+    do {
+        traverse_ptr next_tp;
+        
+        if (tp.item->key.obj_id == dev->devitem.dev_id && tp.item->key.obj_type == TYPE_DEV_EXTENT) {
+            if (tp.item->size >= sizeof(DEV_EXTENT)) {
+                DEV_EXTENT* de = (DEV_EXTENT*)tp.item->data;
+                
+                if (tp.item->key.offset > lastoff)
+                    add_trim_entry_avoid_sb(Vcb, dev, lastoff, tp.item->key.offset - lastoff);
+
+                lastoff = tp.item->key.offset + de->length;
+            } else {
+                ERR("(%llx,%x,%llx) was %u bytes, expected %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(DEV_EXTENT));
+                return;
+            }
+        }
+    
+        b = find_next_item(Vcb, &tp, &next_tp, FALSE, NULL);
+        
+        if (b) {
+            tp = next_tp;
+            if (tp.item->key.obj_id > searchkey.obj_id || (tp.item->key.obj_id == searchkey.obj_id && tp.item->key.obj_type > searchkey.obj_type))
+                break;
+        }
+    } while (b);
+    
+    if (lastoff < dev->devitem.num_bytes)
+        add_trim_entry_avoid_sb(Vcb, dev, lastoff, dev->devitem.num_bytes - lastoff);
+    
+    if (dev->num_trim_entries == 0)
+        return;
+    
+    datalen = sector_align(sizeof(DEVICE_MANAGE_DATA_SET_ATTRIBUTES), sizeof(UINT64)) + (dev->num_trim_entries * sizeof(DEVICE_DATA_SET_RANGE));
+    
+    dmdsa = ExAllocatePoolWithTag(PagedPool, datalen, ALLOC_TAG);
+    if (!dmdsa) {
+        ERR("out of memory\n");
+        goto end;
+    }
+        
+    dmdsa->Size = sizeof(DEVICE_MANAGE_DATA_SET_ATTRIBUTES);
+    dmdsa->Action = DeviceDsmAction_Trim;
+    dmdsa->Flags = DEVICE_DSM_FLAG_TRIM_NOT_FS_ALLOCATED;
+    dmdsa->ParameterBlockOffset = 0;
+    dmdsa->ParameterBlockLength = 0;
+    dmdsa->DataSetRangesOffset = sector_align(sizeof(DEVICE_MANAGE_DATA_SET_ATTRIBUTES), sizeof(UINT64));
+    dmdsa->DataSetRangesLength = dev->num_trim_entries * sizeof(DEVICE_DATA_SET_RANGE);
+    
+    ranges = (DEVICE_DATA_SET_RANGE*)((UINT8*)dmdsa + dmdsa->DataSetRangesOffset);
+    
+    i = 0;
+    le = dev->trim_list.Flink;
+    while (le != &dev->trim_list) {
+        space* s = CONTAINING_RECORD(le, space, list_entry);
+        
+        ranges[i].StartingOffset = s->address;
+        ranges[i].LengthInBytes = s->size;
+        i++;
+        
+        le = le->Flink;
+    }
+    
+    Status = dev_ioctl(dev->devobj, IOCTL_STORAGE_MANAGE_DATA_SET_ATTRIBUTES, dmdsa, datalen, NULL, 0, TRUE, NULL);
+    if (!NT_SUCCESS(Status))
+        WARN("IOCTL_STORAGE_MANAGE_DATA_SET_ATTRIBUTES returned %08x\n", Status);
+    
+    ExFreePool(dmdsa);
+    
+end:
+    while (!IsListEmpty(&dev->trim_list)) {
+        space* s = CONTAINING_RECORD(RemoveHeadList(&dev->trim_list), space, list_entry);
+        ExFreePool(s);
+    }
+    
+    dev->num_trim_entries = 0;
+}
+
 #ifndef __REACTOS__
 static void balance_thread(void* context) {
 #else
@@ -2554,11 +2593,13 @@
     NTSTATUS Status;
     
     Vcb->balance.stopping = FALSE;
-    Vcb->balance.cancelling = FALSE;
     KeInitializeEvent(&Vcb->balance.finished, NotificationEvent, FALSE);
     
-    if (Vcb->balance.opts[BALANCE_OPTS_DATA].flags & BTRFS_BALANCE_OPTS_ENABLED && Vcb->balance.opts[BALANCE_OPTS_DATA].flags & BTRFS_BALANCE_OPTS_CONVERT)
+    if (Vcb->balance.opts[BALANCE_OPTS_DATA].flags & BTRFS_BALANCE_OPTS_ENABLED && Vcb->balance.opts[BALANCE_OPTS_DATA].flags & BTRFS_BALANCE_OPTS_CONVERT) {
         Vcb->data_flags = BLOCK_FLAG_DATA | (Vcb->balance.opts[BALANCE_OPTS_DATA].convert == BLOCK_FLAG_SINGLE ? 0 : Vcb->balance.opts[BALANCE_OPTS_DATA].convert);
+        
+        FsRtlNotifyVolumeEvent(Vcb->root_file, FSRTL_VOLUME_CHANGE_SIZE);
+    }
     
     if (Vcb->balance.opts[BALANCE_OPTS_METADATA].flags & BTRFS_BALANCE_OPTS_ENABLED && Vcb->balance.opts[BALANCE_OPTS_METADATA].flags & BTRFS_BALANCE_OPTS_CONVERT)
         Vcb->metadata_flags = BLOCK_FLAG_METADATA | (Vcb->balance.opts[BALANCE_OPTS_METADATA].convert == BLOCK_FLAG_SINGLE ? 0 : Vcb->balance.opts[BALANCE_OPTS_METADATA].convert);
@@ -2584,13 +2625,14 @@
             }
         } else {
             if (Vcb->need_write) {
-                LIST_ENTRY rollback;
+                Status = do_write(Vcb, NULL);
                 
-                InitializeListHead(&rollback);
-                do_write(Vcb, NULL, &rollback);
                 free_trees(Vcb);
                 
-                clear_rollback(Vcb, &rollback);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("do_write returned %08x\n", Status);
+                    goto end;
+                }
             }
         }
     }
@@ -2655,6 +2697,21 @@
             NTSTATUS Status;
             BOOL changed;
             
+            if (!c->cache_loaded) {
+                ExAcquireResourceExclusiveLite(&c->lock, TRUE);
+                
+                Status = load_cache_chunk(Vcb, c, NULL);
+                
+                if (!NT_SUCCESS(Status)) {
+                    ERR("load_cache_chunk returned %08x\n", Status);
+                    Vcb->balance.status = Status;
+                    ExReleaseResourceLite(&c->lock);
+                    goto end;
+                }
+                
+                ExReleaseResourceLite(&c->lock);
+            }
+            
             do {
                 changed = FALSE;
                 
@@ -2711,6 +2768,21 @@
         c = CONTAINING_RECORD(le, chunk, list_entry_balance);
         
         if (c->chunk_item->type & BLOCK_FLAG_METADATA || c->chunk_item->type & BLOCK_FLAG_SYSTEM) {
+            if (!c->cache_loaded) {
+                ExAcquireResourceExclusiveLite(&c->lock, TRUE);
+                
+                Status = load_cache_chunk(Vcb, c, NULL);
+                
+                if (!NT_SUCCESS(Status)) {
+                    ERR("load_cache_chunk returned %08x\n", Status);
+                    Vcb->balance.status = Status;
+                    ExReleaseResourceLite(&c->lock);
+                    goto end;
+                }
+                
+                ExReleaseResourceLite(&c->lock);
+            }
+            
             do {
                 FsRtlEnterFileSystem();
                 
@@ -2794,6 +2866,24 @@
             ExReleaseResourceLite(&Vcb->tree_lock);
             FsRtlExitFileSystem();
         }
+        
+        if (Vcb->trim && !Vcb->options.no_trim) {
+            FsRtlEnterFileSystem();
+            ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
+            
+            le = Vcb->devices.Flink;
+            while (le != &Vcb->devices) {
+                device* dev2 = CONTAINING_RECORD(le, device, list_entry);
+                
+                if (dev2->devobj && !dev2->readonly && dev2->trim)
+                    trim_unalloc_space(Vcb, dev2);
+                
+                le = le->Flink;
+            }
+            
+            ExReleaseResourceLite(&Vcb->tree_lock);
+            FsRtlExitFileSystem();
+        }
     }
     
     ZwClose(Vcb->balance.thread);
@@ -2813,6 +2903,16 @@
     if (!SeSinglePrivilegeCheck(RtlConvertLongToLuid(SE_MANAGE_VOLUME_PRIVILEGE), processor_mode))
         return STATUS_PRIVILEGE_NOT_HELD;
     
+    if (Vcb->locked) {
+        WARN("cannot start balance while locked\n");
+        return STATUS_DEVICE_NOT_READY;
+    }
+    
+    if (Vcb->scrub.thread) {
+        WARN("cannot start balance while scrub running\n");
+        return STATUS_DEVICE_NOT_READY;
+    }
+    
     if (Vcb->balance.thread) {
         WARN("balance already running\n");
         return STATUS_DEVICE_NOT_READY;
@@ -3064,7 +3164,6 @@
     
     Vcb->balance.paused = FALSE;
     Vcb->balance.stopping = TRUE;
-    Vcb->balance.cancelling = TRUE;
     Vcb->balance.status = STATUS_SUCCESS;
     KeSetEvent(&Vcb->balance.event, 0, FALSE);
     
